<%
String seriesName = request.getParameter("values");
String flow = request.getParameter("onClickFlow");
String seriesJSON = String.valueOf(request.getSession().getAttribute(seriesName));
%>
<!doctype html>
<html>
	<head>
		<title>L2S - Bar Chart</title>
		<script src="Chart.js/Chart.js"></script>
		<script src="Chart.js/core.js"></script>
	</head>
	<body>
		<div style="width: 95%; height: 95%; float: bottom">
			<canvas id="canvas" width="790" height="215"></canvas>
		</div>
	<script>
	var serieValues = <%=seriesJSON%>;
	var serieLabels = new Array();
	var serieData = new Array();
	var flowName = '<%=flow%>';
	
	for(var i = 0; i < serieValues.length; i++) {
		var item = serieValues[i];
		serieLabels.push(item[0]);
		serieData.push(item[1]);
	}
	
	var barChartData = {
		labels : serieLabels,
		datasets : [
			{
				fillColor : "rgba(151,187,205,0.5)",
				strokeColor : "rgba(151,187,205,0.8)",
				highlightFill : "rgba(151,187,205,0.75)",
				highlightStroke : "rgba(151,187,205,1)",
				data : serieData
			}
		]

	}
	window.onload = function(){
		var ctx = document.getElementById("canvas").getContext("2d");
		window.myBar = new Chart(ctx).Bar(barChartData, {
			responsive : true,
			maintainAspectRatio: false
		});
		if (flowName){
		document.getElementById("canvas").onclick = function(evt){
			  var activeBars = window.myBar.getBarsAtEvent(evt);
			  for (var idx in activeBars){
				  callFlow(flowName,[activeBars[idx].label]);
			  }
		}
				       
        };
		
	}

	</script>	
	</body>
</html>
