<!doctype html>

<html>
  <head>
    <title>Velocimetro</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    
    <style>
      body {
		margin: 0px;
		width:215px;
		height:150px;
		overflow: hidden;
		backgroundColor: red;
      }
      
      #simpleGauge {
        width:215px; height:150px;
        display: inline-block;
        margin: 0px;
		overflow: hidden;
      }
    </style>
    
    <script src="justGage.1.0.1/resources/js/raphael.2.1.0.min.js"></script>
    <script src="justGage.1.0.1/resources/js/justgage.1.0.1.js"></script>
	<script src="Chart.js/core.js"></script>
    <script>
	
	function getURLParam(name) {
      var regexS = "[\\?&]"+name+"=([^&#]*)";
      var regex = new RegExp( regexS );
      var tmpURL = window.location.href;
      var results = regex.exec(tmpURL);
      if( results == null )
        return "";
      else
        return unescape(results[1]);
    };
	
    var simpleGauge;
      
    window.onload = function(){
        var simpleGauge = new JustGage({
          id: "simpleGauge", 
          value: parseInt(getURLParam('currValue')), 
          min: parseInt(getURLParam('minValue')),
          max: parseInt(getURLParam('maxValue')),
		  levelColors: ['#ff0000', '#0000ff', '#00ffff', '#00ff00'],
          title: getURLParam('title'),
          label: getURLParam('label'),
		  click: getURLParam('onClickFlow')
		  });
		
	}
    </script>
	</head>
  <body>    
    <div id="simpleGauge"></div>
	<!-- Esta  uma adaptao da justGauge para Maker 2.x e 3.x feita pela L2 Solues Tecnolgica Ltda - http://www.l2s.com.br/ -->
  </body>
</html>