<!doctype html>
<html>
  <head>
    <title>Velocimetro</title>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
    
    <style>
      body {
		margin: 0px;
		width:100%;
		height:100%;
		overflow: hidden;
		backgroundColor: red;
      }
      
      #simpleGauge {
        width:auto !important; height:auto !important;
        display: block;
        margin: 0px;
		overflow: hidden;
		position: absolute;
        top: calc(50% - 75px);
       left: calc(50% - 150px);
      }
	  
	  svg{
		  position: absolute;
		  margin: 0 auto;
	  }
    </style>
    
    <script src="justGage.1.0.1/resources/js/raphael.2.1.0.min.js"></script>
    <script src="justGage.1.0.1/resources/js/justgage.1.0.1.js"></script>
	<script src="Chart.js/core.js"></script>
    <script>
	
	function getURLParam(name) {
      var regexS = "[\\?&]"+name+"=([^&#]*)";
      var regex = new RegExp( regexS );
      var tmpURL = window.location.href;
      var results = regex.exec(tmpURL);
      if( results == null )
        return "";
      else
        return decodeURIComponent(results[1]);
    };
	
    var simpleGauge;
      
    window.onload = function(){
        var simpleGauge = new JustGage({
          id: "simpleGauge", 
          value: parseInt(getURLParam('currValue')), 
          min: parseInt(getURLParam('minValue')),
          max: parseInt(getURLParam('maxValue')),
		  levelColors: ['#ff0000', '#0000ff', '#00ffff', '#00ff00'],
          title: getURLParam('title'),
          label: getURLParam('label')
		  });
		
		document.refreshValues = function(n) {
			simpleGauge.refresh(n);
		}
	}
    </script>
	</head>
  <body unselectable="on" onselectstart="return false;">    
    <center><div id="simpleGauge"></div></center>
	<!-- Esta  uma adaptao da justGauge para Maker 2.x e 3.x feita pela L2 Solues Tecnolgica Ltda - http://www.l2s.com.br/ -->
  </body>
</html>