﻿<!DOCTYPE html>
<html>
	<head>
		<title>Dashboard - L2MAKER</title>
		<meta content="text/html; charset=utf-8" http-equiv="content-type">
		<!--[if IE]><base href="<% 
		String baseURL = request.getRequestURL().toString().replace("/l2s/dashboard/index.jsp", "/");
		out.print(baseURL); %>"></base><![endif]-->
		<!--[if !IE]>--><base href="../.." /><!--<![endif]-->
		<meta name="description" content="www.l2maker.com.br - Dashboard" />
		<meta name="keywords" content="L2S, L2MAKER, API Maker, Softwell Maker, dashboard"/>
		<link rel="icon" href="favicon.ico" type="image/x-icon" />

		<link rel="stylesheet" type="text/css" href="l2s/dashboard/freewall/css/style.css" />
		<link rel="stylesheet" type="text/css" href="l2s/dashboard/freewall/css/csshake.min.css" />

		<script type="text/javascript" src="l2s/dashboard/jquery-2.0.2.min.js"></script>
		<script type="text/javascript" src="l2s/dashboard/jquery-ui-1.10.3.min.js"></script>
		<script type="text/javascript" src="l2s/dashboard/freewall/freewall.js"></script>
		<!-- MENU -->
		<link rel="stylesheet" href="l2s/dashboard/contextmenu/jquery.contextMenu.css" type="text/css" media="screen">
		<script type="text/javascript" src="l2s/dashboard/contextmenu/jquery.ui.position.min.js"></script>
		<script type="text/javascript" src="l2s/dashboard/contextmenu/jquery.contextMenu.js"></script>
		<!-- -->
		<!-- Required D3 library -->
		<script src="//d3js.org/d3.v4.js"></script>

		<!-- D3Funnel source file -->
		<script src="l2s/dashboard/funnel/d3-funnel.dist.js"></script>
		
		<script type="text/javascript" src="l2s/commons/core.js"></script>
		<script type="text/javascript" src="l2s/dashboard/dashboard.js.jsp"></script>
		<!-- GRAFICOS -->
		<script src="l2s/dashboard/Chart.js/Chart.js"></script>
		<script src="l2s/dashboard/Chart.js/core.js"></script>
		<!-- -->
		<style type="text/css">
			html, body {
				margin: 0;
				padding: 0;
			}

			.layout {
				padding: 15px;
			}
			
			.free-wall {
			}

			.filter-items {
				padding: 10px 0px;
			}

			.filter-label {
				display: inline-block;
				margin: 0px 5px 5px 0px;
				padding: 10px;
				cursor: pointer;
				background: rgba(255, 255, 255, 0.4);
			}

			.filter-label-all {
				background: rgb(205, 149, 12);
			}

			.filter-label.active,
			.filter-label:hover {
				background: rgb(238, 180, 34);
			}
			
			.item-actions {
				position: absolute;
				right: 4px;
				top: 4px;
			}

			.item-image {
				position: absolute;
				right: 4px;
				bottom: 4px;
			}
			
			.item-group-Graficos {
color: rgb(0, 0, 0);
    background: #EAEFF2 !important;
	border-bottom: 5px solid #17A6DE;
		
}

.chart-titulo {
	margin: auto;
}

.pie-legend li {
	display: inline-block;
	padding: 5px;
	font: 11px;
}

.pie-legend li span {
    width: 1em;
    height: 1em;
    display: inline-block;
    margin-right: 5px;
}
.pie-legend {
    list-style: none;  
	font-size: 10px;
}
		</style>
		<%
		String theme = request.getParameter("skin"); 
		if(theme == null || theme.equals("")) { 
			theme = "default"; 
		}
		%>
		<link rel="stylesheet" type="text/css" href="l2s/dashboard/themes/<%=theme%>/theme.css" />
		<link rel="stylesheet" type="text/css" href="l2s/dashboard/themes/<%=theme%>/jquery.ui.tooltip.css" />
	</head>
<body>
	<div class="layout" unselectable="on"
				onselectstart="return false;" >
		<%
		String onExecuteAction = request.getParameter("onExecuteAction");
		if((onExecuteAction != null) && !"".equals(onExecuteAction) && !"null".equals(onExecuteAction)) {
		%>
		<div id="actionTextDiv">
			<input type="text" id="actionText" name="actionText" value="">
			<input type="button" id="actionButton" name="actionTextBtn" value="OK"></input>
		</div>
		<script>
		$("#actionButton").click(function() {
			callFlow('<%=onExecuteAction%>', [$("#actionText").val()]);
		});
		</script>
		<%}%>
		<div class="filter-items" id="filterGroup" style="display: none">
			<div class="filter-label filter-label-all" id="filterAll">Todos</div>
		</div>
		<div id="freewall" class="free-wall">
			<!-- ITENS -->
		</div>
	</div>

<script type="text/javascript">
	window.CELL_W = <% String width = request.getParameter("width"); if(width == null || width.equals("")) { out.print("160"); }  else { out.print(width); } %>;
	window.CELL_H = <% String height = request.getParameter("height"); if(height == null || height.equals("")) { out.print("160"); }  else { out.print(height); } %>;
	$(function() {
		var wall = new Freewall("#freewall");
		wall.reset({
			selector: '.brick',
			draggable: false,
			animate: true,
			cellW: CELL_W,
			cellH: CELL_H,
			fixSize: 0,
			onResize: function() {
				wall.refresh();
			},
			keepOrder: true,
			draggable: true,
		});

		wall.filter("");
		$(".filter-label").click(function() {
			$(".filter-label").removeClass("active");
			var filter = $(this).addClass('active').data('filter');
			if (filter) {
				wall.filter(filter);
			} else {
				wall.unFilter();
			}
		});

		var onMouseEvent = getURLParam('onMouseEvent');
		var onDropOver = getURLParam('onDropEvent');
		var onDataRefresh = getURLParam('onDataRefresh');
		var refreshInterval = getURLParam('refreshInterval');
		var refreshAll = getURLParam('refreshAll') == '1';
		var dash = new Dashboard(wall, refreshInterval, refreshAll, onDataRefresh, onMouseEvent, onDropOver);
		window._dashboard = dash;
		document._dashboard = dash;
	});
</script>
<script type="text/javascript">
function Dashboard(wall, refreshInterval, refreshAll, onDataRefresh, onMouseEvent, onDropOver) {
	this.wall = wall;
	this.itens = new Array();
	this.onDataRefresh = onDataRefresh;
	this.onMouseEvent = onMouseEvent;
	this.onDropOver = onDropOver;
	this.refreshInterval = refreshInterval;
	this.refreshAll = refreshAll;
	this.startAutoRefresh(refreshInterval, refreshAll);
}

Dashboard.prototype.removerItem = function(id) {
	var itemDiv = this.getItem(id).get(0);
	$(itemDiv).remove();
}

Dashboard.prototype.addItemText = function(id, titulo, detalhes, grupo, tamanho, imgSrc, descricao) {
	tamanho = tamanho ? tamanho.replace(/\D+/g, '') : '11';//1:1 ou 1x1
	var itemSize = tamanho ? 'size' + tamanho : 'size11';
	var itemID = 'item_' + id;
	var itemDiv = this.getItem(id).get(0);
	var itemDivCover = false;
	var itemImg = false;
	var newItem = true;
	if(itemDiv) {
		$(itemDiv).find('.item-head').html(titulo);
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDivCover = $(itemDiv).find('.cover');
		itemImg = $(itemDiv).find('.item-image');
		$(itemDivCover).find('.item-detail').remove();
		newItem = false;
		
		if(imgSrc) {
			itemImg.attr('src', imgSrc);
			itemImg.show();
		} else {
			itemImg.hide();
		}
	} else {
		itemDiv = document.createElement('div');
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDiv.id = itemID;
		itemDiv.draggable = 'true';
		itemDiv.setAttribute('codigo', id);
		itemDiv.addEventListener('click', function(event) { window._dashboard.fireMouseAction(id, -1, 'CLICK', event); });
		itemDiv.addEventListener('dblclick', function(event) { window._dashboard.fireMouseAction(id, -1, 'DBLCLICK', event); });
		itemDiv.addEventListener('dragover', function(event) { event.preventDefault(); });
		itemDiv.addEventListener('drop', function(event) {
				var data = event.dataTransfer.getData("text/plain");
				window._dashboard.fireDropAction(id, data, event); 
			});
		itemDiv.addEventListener('dragstart', function(ev) {
			ev.dataTransfer.setData("text", id);
		});
		var itemDivCover = document.createElement('div');
		itemDivCover.className = 'cover';
		itemDiv.appendChild(itemDivCover);

		var itemDivActions = document.createElement('div');
		itemDivActions.className = 'item-actions';
		itemDivActions.innerText = '...';
		
		itemDivActions.addEventListener('click', function(event) { 
				event.preventDefault(); 
				event.stopPropagation(); 
				var rect = itemDivActions.getBoundingClientRect();
				$(itemDiv).contextMenu({x: rect.left - 50, y: rect.bottom + 4}); 
			});
		itemDiv.appendChild(itemDivActions);

		var itemHead = document.createElement('h2');
		itemHead.className = 'item-head';
		itemHead.innerText = titulo;
		itemDivCover.appendChild(itemHead);

		itemImg = document.createElement('img');
		itemImg.className = 'item-image';
		itemDivCover.appendChild(itemImg);
		if(imgSrc) {
			itemImg.src = imgSrc;
			itemImg.style.display = 'block';
		} else {
			itemImg.style.display = 'none';
		}
	}

	if(!detalhes) {
		detalhes = new Array();
	} else if(detalhes.constructor !== Array) {
		detalhes = [ detalhes ];
	}

	for(var idx in detalhes) {
		var itemDetalhe = document.createElement('div');
		itemDetalhe.className = 'item-detail item-detail-' + idx;
		var detailContent = detalhes[idx];
		if(detailContent && detailContent.startsWith('<')) {
			itemDetalhe.innerHTML = detailContent;
		} else {
			itemDetalhe.innerText = detailContent;
		}
		$(itemDivCover).append(itemDetalhe);
	}
	if(descricao) {
		itemDiv.title = descricao;
		$( itemDiv ).tooltip({
				content: descricao,
				track: true
		});
	}
	if(newItem) {
		document.getElementById('freewall').appendChild(itemDiv);
		this.wall.fitWidth();
	}
}

Dashboard.prototype.addImage = function(id, titulo, imgSrc, descricao, grupo, tamanho) {
	tamanho = tamanho ? tamanho.replace(/\D+/g, '') : '11';//1:1 ou 1x1
	var itemSize = tamanho ? 'size' + tamanho : 'size11';
	var itemID = 'item_' + id;
	var itemDiv = this.getItem(id).get(0);
	var itemDivCover = false;
	var itemImg = false;
	var newItem = true;
	if(itemDiv) {
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDivCover = $(itemDiv).find('.cover');
		itemImg = $(itemDiv).find('.item-image');
		$(itemDivCover).find('.item-detail').remove();
		newItem = false;
		itemDiv.refreshValues(dados);
	} else {
		itemDiv = document.createElement('div');
		var groupID = 'item-group-' + grupo;
		var g = $('#' + groupID)[0];
		if(g) {
			var _cssRules = g._cssRules;
			if(_cssRules) {
				itemDiv.style = ' ' + _cssRules;
			}
		}
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDiv.id = itemID;
		itemDiv.draggable = 'true';
		itemDiv.setAttribute('codigo', id);
		itemDiv.addEventListener('click', function(event) { window._dashboard.fireMouseAction(id, -1, 'CLICK', event); });
		itemDiv.addEventListener('dblclick', function(event) { window._dashboard.fireMouseAction(id, -1, 'DBLCLICK', event); });
		//itemDiv.addEventListener('dragover', function(event) { event.preventDefault(); });
		itemDiv.addEventListener('drop', function(event) {
				var data = event.dataTransfer.getData("text/plain")
				window._dashboard.fireDropAction(id, data, event); 
			});
		itemDiv.addEventListener('dragstart', function(ev) {
			ev.dataTransfer.setData("text", id);
		});

		var itemDivActions = document.createElement('div');
		itemDivActions.className = 'item-actions';
		itemDivActions.innerText = '...';
		
		var itemHead = document.createElement('h3');
		itemHead.className = 'item-head';
		itemHead.innerText = titulo;
		itemHead.style.fontSize = '16px';
		itemHead.style.height = '20px';
		itemDiv.appendChild(itemHead);

		itemImg = document.createElement('img');

		itemImg.className = 'item-image';
		itemDiv.appendChild(itemImg);
		itemImg.style.width = '95%';
		itemImg.style.height = 'calc(100% - 20px)';
		if(imgSrc) {
			itemImg.src = imgSrc;
			itemImg.style.display = 'block';
		} else {
			itemImg.style.display = 'none';
		}

		itemDivActions.addEventListener('click', function(event) { 
				event.preventDefault(); 
				event.stopPropagation(); 
				var rect = itemDivActions.getBoundingClientRect();
				$(itemDiv).contextMenu({x: rect.left - 50, y: rect.bottom + 4}); 
			});
		itemDiv.appendChild(itemDivActions);
		
	}

	if(descricao) {
		itemImg.alt = descricao;
	}

	if(newItem) {
		document.getElementById('freewall').appendChild(itemDiv);
		this.wall.fitWidth();
	}
}

Dashboard.prototype.addChart = function(id, grafico, titulo, dados, grupo, tamanho, descricao) {
	tamanho = tamanho ? tamanho.replace(/\D+/g, '') : '11';//1:1 ou 1x1
	var itemSize = tamanho ? 'size' + tamanho : 'size11';
	var itemID = 'item_' + id;
	var itemDiv = this.getItem(id).get(0);
	var itemDivCover = false;
	var itemImg = false;
	var newItem = true;
	if(itemDiv) {
		//$(itemDiv).find('.item-head').html(titulo);
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDivCover = $(itemDiv).find('.cover');
		itemImg = $(itemDiv).find('.item-image');
		$(itemDivCover).find('.item-detail').remove();
		newItem = false;
		itemDiv.refreshValues(dados);
	} else {
		itemDiv = document.createElement('div');
		var groupID = 'item-group-' + grupo;
		var g = $('#' + groupID)[0];
		if(g) {
			var _cssRules = g._cssRules;
			if(_cssRules) {
				itemDiv.style = ' ' + _cssRules;
			}
		}
		itemDiv.className = 'brick item-group-' + grupo + ' ' + itemSize;
		itemDiv.id = itemID;
		itemDiv.draggable = 'true';
		itemDiv.setAttribute('codigo', id);
		itemDiv.addEventListener('click', function(event) { window._dashboard.fireMouseAction(id, -1, 'CLICK', event); });
		itemDiv.addEventListener('dblclick', function(event) { window._dashboard.fireMouseAction(id, -1, 'DBLCLICK', event); });
		itemDiv.addEventListener('dragover', function(event) { event.preventDefault(); });
		itemDiv.addEventListener('drop', function(event) {
				var data = event.dataTransfer.getData("text/plain")
				window._dashboard.fireDropAction(id, data, event); 
			});
		itemDiv.addEventListener('dragstart', function(ev) {
			ev.dataTransfer.setData("text", id);
		});

		var itemDivActions = document.createElement('div');
		itemDivActions.className = 'item-actions';
		itemDivActions.innerText = '...';
		
		itemDivActions.addEventListener('click', function(event) { 
				event.preventDefault(); 
				event.stopPropagation(); 
				var rect = itemDivActions.getBoundingClientRect();
				$(itemDiv).contextMenu({x: rect.left - 50, y: rect.bottom + 4}); 
			});
		itemDiv.appendChild(itemDivActions);
		if(grafico == 'FUNIL') {
			this.addFunil(itemDiv, dados, titulo);
		} else if(grafico == 'BARRAS') {
			this.addChartBars(itemDiv, dados, titulo);
		} else if(grafico == 'PIZZA') {
			this.addChartPie(itemDiv, dados, titulo);
		} else if(grafico == 'LINHAS') {
			this.addChartLines(itemDiv, dados, titulo);
		} else {
			var itemFrame = document.createElement('iframe');
			itemFrame.className = 'item-frame';
			itemFrame.style.width = '100%';
			itemFrame.style.height = '100%';
			itemFrame.style.border = '0px';
			itemFrame.style.overflow = "hidden";
			itemDiv.appendChild(itemFrame);
			var label = '';
			if(!dados) {
				dados = {minValue: 0, maxValue: 0, value: 0};
			}
			var minValue = dados.minValue ? dados.minValue : 0;
			var maxValue = dados.maxValue ? dados.maxValue : 100;
			var currValue = dados.value ? dados.value : 0;
			itemFrame.src = 'l2s/charts/simpleGauge2.jsp?title=' + encodeURIComponent(titulo) + '&label=' + label + '&minValue=' + minValue +'&maxValue=' + maxValue + '&currValue=' + currValue +'&';
			itemDiv.itemFrame = itemFrame;

			itemDiv.refreshValues = function(values) {
				itemFrame.contentDocument.refreshValues(values ? values.value : 0);
			}
		}
	}

	if(descricao) {
		itemDiv.title = descricao;
		$( itemDiv ).tooltip({
				content: descricao,
				track: false
		});
	}

	if(newItem) {
		document.getElementById('freewall').appendChild(itemDiv);
		this.wall.fitWidth();
	}
}

Dashboard.prototype.addChartBars = function(itemDiv, dados, titulo) {
	var serieData = toChartData(dados);

	var divTitulo = document.createElement('span');
	divTitulo.style.width = '100%'; 
	divTitulo.style.height = '10%';
	divTitulo.class = 'chart-titulo';
	divTitulo.innerHTML = '<center>' + titulo + '</center>';
	itemDiv.appendChild(divTitulo);

	var divGrafico = document.createElement('div');
	divGrafico.style.width = '100%'; 
	divGrafico.style.height = '90%';
	itemDiv.appendChild(divGrafico);

	var divGBarras = document.createElement('canvas');
	divGBarras.id = "canvas" + itemDiv.id;
	divGrafico.appendChild(divGBarras);
	var graficoBarras = false;
	setTimeout(function() {
		var ctx = divGBarras.getContext("2d");
		graficoBarras = new Chart(ctx, {
			type: 'bar',
			data: serieData,
			options: {
				responsive: true,
				maintainAspectRatio: false,
				legend: {
					display: false
				}
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
			
			graficoBarras.data = toChartData(serieData);
			if(graficoBarras.update) {
				graficoBarras.update();
			}
		}
}

Dashboard.prototype.addChartLines = function(itemDiv, dados, titulo) {
	var graficoBarras = false;
	var serieData = toChartData(dados);
	serieData.datasets[0].backgroundColor = "rgba(151,187,205,0.5)";
	serieData.datasets[0].borderColor = "rgba(151,187,205,0.8)";

	var divTitulo = document.createElement('span');
	divTitulo.style.width = '100%'; 
	divTitulo.style.height = '10%';
	divTitulo.class = 'chart-titulo';
	divTitulo.innerHTML = '<center>' + titulo + '</center>';
	itemDiv.appendChild(divTitulo);

	var divGrafico = document.createElement('div');
	divGrafico.style.width = '100%'; 
	divGrafico.style.height = '90%';
	itemDiv.appendChild(divGrafico);

	var divGBarras = document.createElement('canvas');
	divGBarras.id = "canvas-linhas-" + itemDiv.id;
	divGrafico.appendChild(divGBarras);
	setTimeout(function() {
		var ctx = divGBarras.getContext("2d");
		graficoBarras = new Chart(ctx, {
			type: 'line',
			data: serieData,
			options: {
				responsive: true,
				maintainAspectRatio: false,
				legend: {
					display: false
				}
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
			var serieData = toChartData(dados);
			serieData.datasets[0].backgroundColor = "rgba(151,187,205,0.5)";
			serieData.datasets[0].borderColor = "rgba(151,187,205,0.8)";
			graficoBarras.data = serieData;
			if(graficoBarras.update) {
				graficoBarras.update();
			}
		}
}

Dashboard.prototype.addChartPie = function(itemDiv, dados, titulo) {
	var serieData = toChartData(dados);
	var divTopo = document.createElement('div');
	divTopo.class = 'chart-titulo';
	itemDiv.appendChild(divTopo);
	var divTitulo = document.createElement('span');
	divTitulo.class = 'chart-titulo';
	divTitulo.innerHTML = '<center>' + titulo + '</center>';
	divTopo.appendChild(divTitulo);

	var divGrafico = document.createElement('div');
	divGrafico.id = "canvas-content" + itemDiv.id;
	divGrafico.style.width = '100%'; 
	divGrafico.style.height = '80%';
	itemDiv.appendChild(divGrafico);

	var divChart = document.createElement('canvas');
	divChart.style.width = '95%'; 
	divChart.style.height = '95%';

	divChart.id = "canvas" + itemDiv.id;
	divGrafico.appendChild(divChart);
	var graficoPizza = false;
	setTimeout(function() {
		var ctx = divChart.getContext("2d");
		graficoPizza = new Chart(ctx, {
			type: 'pie',
			data: serieData,
			options: {
			responsive: true,
			maintainAspectRatio: false,
			legendTemplate : "<ul class=\"<" + "%=name.toLowerCase()%" + ">-legend\"><" + "% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<" + "%=segments[i].fillColor%"+">\"></span><" + "%if(segments[i].label){%" + "><" + "%=segments[i].label%" + "><" + "%}%" + "></li><" + "%}%" + "></ul>",
			legendTemplate: "<ul class=\"<" + "%=name.toLowerCase()%" + ">-legend\"><" + "% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<" + "%=segments[i].fillColor%"+">\"></span><" + "%if(segments[i].label){%" + "><" + "%=segments[i].label%" + "><" + "%}%" + "></li><" + "%}%" + "></ul>"
			}
		});
	}, 500);
	itemDiv.refreshValues = function(values) {
		if(graficoPizza._old_Values && (graficoPizza._old_Values == JSON.stringify(values))) {
			return;//Ignora igual
		}
		graficoPizza._old_Values = JSON.stringify(values);

		var serieData = toChartData(dados);
		graficoPizza.data = serieData;
		if(graficoPizza.update) {
			graficoPizza.update();
		}
	}
}

Dashboard.prototype.addFunil = function(itemDiv, dados, titulo) {
	const FUNNEL_OPTS = {
			chart: {
				bottomPinch: 1,
				curve: {
					enabled: true,
				},
				bottomWidth: 1 / 3,
			},
			block: {
				dynamicHeight: false,
			},
			animate: 200,
		};
	var divTopo = document.createElement('div');
	divTopo.class = 'chart-titulo';
	itemDiv.appendChild(divTopo);

	var divTitulo = document.createElement('span');
	divTitulo.class = 'chart-titulo';
	divTitulo.innerHTML = '<center>' + titulo + '</center>';
	divTopo.appendChild(divTitulo);

	var funilID = "funil" + strhash(itemDiv.id);
	var divGrafico = document.createElement('div');
	divGrafico.id = funilID;
	divGrafico.style.width = '100%'; 
	divGrafico.style.height = '80%';
	itemDiv.appendChild(divGrafico);
	itemDiv._funnel = false;
	//
	setTimeout(function() {
		const chart = new D3Funnel('#' + funilID);
		chart.draw(dados, FUNNEL_OPTS);
		itemDiv._funnel = chart;
	}, 2);

	itemDiv.refreshValues = function(values) {
		itemDiv._funnel.draw(values, FUNNEL_OPTS)
	}
}

Dashboard.prototype.addItemGroup = function(id, descricao, corFundo, corTexto, todos, padrao) {
	var groupID = 'item-group-' + id;
	if(document.getElementById(groupID)) return;
	var cssRules = '';
	if(corFundo) {
		cssRules += 'background: ' + corFundo + ';';
	}
	if(corTexto) {
		cssRules += 'color: ' + corTexto + ';'; 
	}
	createCSSSelector('.' + groupID, cssRules);

	var filterDiv = document.createElement('div');
	filterDiv.className = groupID + ' filter-label';
	filterDiv.setAttribute('data-filter', '.' + groupID);
	filterDiv.innerText = descricao;
	filterDiv.id = groupID;
	filterDiv._cssRules = cssRules;

	var f = document.getElementById('filterGroup');
	f.appendChild(filterDiv);
	f.style.display = 'block';

	var onGroupClick = function(event) {
		$(".filter-label").removeClass("active");
		var filter = $(this).addClass('active').data('filter');
		if (filter) {
			window._dashboard.wall.filter(filter);
		} else {
			window._dashboard.wall.unFilter();
		}
		window._dashboard.wall.fitWidth();
	};

	filterDiv.addEventListener('click', onGroupClick);

	var filterAll = document.getElementById('filterAll');
	if(todos) {
		var att = filterAll.getAttribute('data-filter');
		if(att) {
			att += ', ';
		} else {
			att = '';
		}
		filterAll.setAttribute('data-filter', att + ' .' + groupID);
	}
	if(padrao) {
		$(filterDiv).addClass('active');
	}
}

Dashboard.prototype.removeItem = function(id) {
	this.getItem(id).remove();
	this.wall.fitWidth();
}

Dashboard.prototype.getItem = function(id) {
	return $("[codigo='" + id + "']");
}

Dashboard.prototype.refresh = function(id) {
	if(this.onDataRefresh) {
		try {
			var resposta = callFlow(this.onDataRefresh, id ? [id, 'ITEM'] : ['', 'ALL']);
			if(!resposta) return false;
			resposta = eval('(' + resposta + ')');
			for(var idx in resposta) {
				try {
					var item = resposta[idx];
					if(item.tipo == 'GRUPO') {
						item.todos = (item.todos === false || item.todos === "false") ? false : true;
						item.padrao = (item.padrao === true || item.padrao === "true" || item.padrao === "True");
						this.addItemGroup(item.id, item.titulo, item.corFundo, item.corTexto, item.todos, item.padrao);
					} else if(item.tipo == 'GRAFICO') {
						this.addChart(item.id, item.grafico, item.titulo, item.dados, item.grupo, item.tamanho, item.descricao);
						this.itens[item.id] = item;
					} else if(item.tipo == 'IMAGEM') {
						this.addImage(item.id, item.titulo, item.url, item.descricao, item.grupo, item.tamanho);
						this.itens[item.id] = item;
					} else {
						this.addItemText(item.id, item.titulo, item.detalhes, item.grupo, item.tamanho, item.img, item.descricao);
						this.itens[item.id] = item;	
					}
				} catch (e) {
					console.log(e);

				}
			}
			//Remover os que não retornaram na lista
			if(!id) {
				var itens = new Array();
				for(var idx in resposta) {
					var item = resposta[idx];
					if(item.id) {
						itens.push(item.id);
					}
				}
				for(var idx in this.itens) {
					var item = this.itens[idx];
					if(itens.indexOf(item.id) < 0) {
						this.removerItem(item.id);
					}
				}
				this.wall.fitWidth();
			}
			var _wall = this.wall;
			setTimeout(function() {
				var filterActive = $('.active').data('filter');
				if(!filterActive) {
					filterActive = $('#filterAll').data('filter');
				}
				_wall.filter(filterActive);
			}, 2);
			this.sort();
		} catch (e) {
			throw e;
		}
	}  
}

Dashboard.prototype.startAutoRefresh = function(refreshInterval, refreshAll) {
	var dash = this;
	setTimeout(function() { dash.refresh(null); }, 100);
	if(this.refreshInterval > 0) {
		setInterval(function() { dash.autoRefresh(); }, refreshInterval * 1000);
	}
}

Dashboard.prototype.autoRefresh = function() {
	var dash = this;
	if(this.refreshAll) {
		this.refresh(null);
	} else {
		var minValue = null;
		var minDiv = null;
		$('.brick').each(function() {
			var refreshCount = parseInt(this.getAttribute('refresh-count'));
			if(isNaN(refreshCount)) {
				refreshCount = 0;
			}
			if ((minValue === null) || (refreshCount < minValue)) { 
					minValue = refreshCount; 
					minDiv = this;
			}
		});
		if(minDiv) {
			var codigo = minDiv.getAttribute('codigo');
			minDiv.setAttribute('refresh-count', minValue + 1);
			dash.refresh(codigo);
		} else {
			dash.refresh(null);
		}
	}
}

Dashboard.prototype.fireDropAction = function(id, idRemoto, event) {
	console.log("DROP:" + id + " / " + idRemoto);
	if(this.onDropOver) {
		try {
			var resposta = callFlow(this.onDropOver, [id, idRemoto]);
			if(event) {
				event.stopPropagation();
			}
			return true;
		} catch (e) {
			alert(e);
		}
	}
	if(event) {
		event.stopPropagation();
	}
	return false;
}

Dashboard.prototype.fireMouseAction = function(id, item, acao, event) {
	console.log(acao);
	if(this.onMouseEvent) {
		try {
			var x = mouseX(event);
			var y = mouseY(event);
			var resposta = callFlow(this.onMouseEvent, [id, item, acao, x, y]);
			if(event) {
				event.stopPropagation();
			}
			return true;
		} catch (e) {
			alert(e);
		}
	}
	if(event) {
		event.stopPropagation();
	}
	return false;
}

Dashboard.prototype.fireGetActions = function(id) {
	if(this.onDataRefresh) {
		try {
			var item = this.itens[id];
			if(item && item.menu) {
				return item.menu;
			} else {
				var resposta = callFlow(this.onDataRefresh, [id, 'MENU']);
				if(!resposta) return false;
				resposta = eval('(' + resposta + ')');
				return resposta;
			}
		} catch (e) {
			throw e;
		}
		return false;
	} 
}

Dashboard.prototype.getItens = function() {
	var ids = [];
	for(var idx in this.itens) {
		ids.push(idx);
	}
	return ids;
}

Dashboard.prototype.sort = function() {
	var _wall = this;
	this.wall.sortBy(function(a, z) {
						var idA = a.getAttribute('codigo');
						var idZ = z.getAttribute('codigo');
						var itemA = _wall.itens[idA];
						var itemZ = _wall.itens[idZ];
						return ((itemA && itemA.ordem) ? itemA.ordem : 999999) - ((itemZ && itemZ.ordem) ? itemZ.ordem : 999999);
					});
}
</script>
<script type="text/javascript">
	function allowDrop(ev) {
		ev.preventDefault();
	}

	function createCSSSelector (selector, style) {
		if (!document.styleSheets) return;
		if (document.getElementsByTagName('head').length == 0) return;

		var styleSheet,mediaType;

		if (document.styleSheets.length > 0) {
			for (var i = 0, l = document.styleSheets.length; i < l; i++) {
				if (document.styleSheets[i].disabled) 
					continue;
				var media = document.styleSheets[i].media;
				mediaType = typeof media;

				if (mediaType === 'string') {
					if (media === '' || (media.indexOf('screen') !== -1)) {
					  styleSheet = document.styleSheets[i];
					}
				} else if (mediaType=='object') {
					if (media.mediaText === '' || (media.mediaText.indexOf('screen') !== -1)) {
					  styleSheet = document.styleSheets[i];
					}
				}

				if (typeof styleSheet !== 'undefined') 
					break;
			}
		}

		if (typeof styleSheet === 'undefined') {
			var styleSheetElement = document.createElement('style');
			styleSheetElement.type = 'text/css';
			document.getElementsByTagName('head')[0].appendChild(styleSheetElement);

			for (i = 0; i < document.styleSheets.length; i++) {
				if (document.styleSheets[i].disabled) {
					continue;
				}
				styleSheet = document.styleSheets[i];
			}

			mediaType = typeof styleSheet.media;
		}

		if (mediaType === 'string') {
			for (var i = 0, l = styleSheet.rules.length; i < l; i++) {
				if(styleSheet.rules[i].selectorText && styleSheet.rules[i].selectorText.toLowerCase() == selector.toLowerCase()) {
					styleSheet.rules[i].style.cssText = style;
						return;
				}
			}
				styleSheet.addRule(selector,style);
		} else if (mediaType === 'object') {
			var styleSheetLength = (styleSheet.cssRules) ? styleSheet.cssRules.length : 0;
			for (var i = 0; i < styleSheetLength; i++) {
				if (styleSheet.cssRules[i].selectorText && styleSheet.cssRules[i].selectorText.toLowerCase() == selector.toLowerCase()) {
					styleSheet.cssRules[i].style.cssText = style;
					return;
				}
			}
			styleSheet.insertRule(selector + '{' + style + '}', styleSheetLength);
		}
	}

	function drag(ev) {
		ev.dataTransfer.setData("text", ev.target.id);
	}
</script>
<script>
function montarMenu(itens) {
	var menu = new Object();
	for(idx in itens) {
		var item = itens[idx];
		var menuItem = { name: item.titulo };
		if(item.icone) {
			menuItem.icon = item.icone;
		}
		if(item.submenu) {
			menuItem.items = montarMenu(item.submenu);
		}
		menu[item.id] = menuItem;
	}
	return menu;
}

$(function(){
    $.contextMenu({
        selector: '.brick', 
        build: function($trigger, e) {
            // this callback is executed every time the menu is to be shown
            // its results are destroyed every time the menu is hidden
            // e is the original contextmenu event, containing e.pageX and e.pageY (amongst other data)
			var itemDiv = $trigger[0];
			var codigo = itemDiv.getAttribute('codigo');
            return {
                callback: function(key, options) {
                    var m = "clicked: " + key;
                    window.console && console.log(m);
					//alert(m + ':' + codigo); 
					window._dashboard.fireMouseAction(codigo, key, 'MENU', event);
                },
                items: montarMenu(window._dashboard.fireGetActions(codigo))
            };
        }
    });
});
</script>
</body>
</html>