<%
String seriesName = request.getParameter("values");
String chartTitle = request.getParameter("title");
String width = request.getParameter("width");
String height = request.getParameter("height");
String seriesJSON = String.valueOf(request.getSession().getAttribute(seriesName));
String flow = request.getParameter("flow");
%>
<!DOCTYPE HTML>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>Pizza</title>
		<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.2/jquery.min.js"></script>
		<style type="text/css">
${demo.css}
		</style>
		<script type="text/javascript">
		
	function getURLParam(name) {
      var regexS = "[\\?&]"+name+"=([^&#]*)";
      var regex = new RegExp( regexS );
      var tmpURL = window.location.href;
      var results = regex.exec(tmpURL);
      if( results == null )
        return "";
      else
        return unescape(results[1]);
    };
	
$(function () {
   var serieValues = <%=seriesJSON%>;
   var flowName = '<%=flow%>';
   /**
 * Grid-light theme for Highcharts JS
 * @author Torstein Honsi
 */

// Load the fonts
Highcharts.createElement('link', {
   href: 'http://fonts.googleapis.com/css?family=Dosis:400,600',
   rel: 'stylesheet',
   type: 'text/css'
}, null, document.getElementsByTagName('head')[0]);

Highcharts.theme = {
   colors: ["#7cb5ec", "#f7a35c", "#90ee7e", "#7798BF", "#aaeeee", "#ff0066", "#eeaaee",
      "#55BF3B", "#DF5353", "#7798BF", "#aaeeee"],
   chart: {
      backgroundColor: null,
      style: {
         fontFamily: "Dosis, sans-serif"
      }
   },
   title: {
      style: {
         fontSize: '16px',
         fontWeight: 'bold',
         textTransform: 'uppercase'
      }
   },
   tooltip: {
      borderWidth: 0,
      backgroundColor: 'rgba(219,219,216,0.8)',
      shadow: false
   },
   legend: {
      itemStyle: {
         fontWeight: 'bold',
         fontSize: '13px'
      }
   },
   xAxis: {
      gridLineWidth: 1,
      labels: {
         style: {
            fontSize: '12px'
         }
      }
   },
   yAxis: {
      minorTickInterval: 'auto',
      title: {
         style: {
            textTransform: 'uppercase'
         }
      },
      labels: {
         style: {
            fontSize: '12px'
         }
      }
   },
   plotOptions: {
      candlestick: {
         lineColor: '#404048'
      }
   },


   // General
   background2: '#F0F0EA'
   
};

// Apply the theme
Highcharts.setOptions(Highcharts.theme);
 Highcharts.getOptions().colors = Highcharts.map(Highcharts.getOptions().colors, function (color) {
        return {
            radialGradient: { cx: 0.5, cy: 0.3, r: 0.7 },
            stops: [
                [0, color],
                [1, Highcharts.Color(color).brighten(-0.3).get('rgb')] // darken
            ]
        };
    });
    $('#container').highcharts({
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: 1,//null,
            plotShadow: false
        },
        title: {
            text: '<%=chartTitle%>'
        },
        tooltip: {
            pointFormat: '<b>{point.percentage:.1f}%</b>'//{series.name}:
        },
        plotOptions: {
            pie: {
                allowPointSelect: true,
                cursor: 'pointer',
                dataLabels: {
                    enabled: true,
                    format: '{point.name}',
                    style: {
                        color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                    }
                },
				showInLegend: false
            }
        },
        series: [{
            type: 'pie',
            name: '',
            data: serieValues,
			point:{
              events:{
                  click: function (event) {
							  if(flowName)
								  callFlow(flowName, [this.name]);
                        }
              }
          }          
        }]
		
    });
});
		</script>
	</head>
	<body>
<script src="highcharts-4.0.4/highcharts.js"></script>
<script src="Chart.js/core.js"></script>
<!-- script src="../highcahrts-4.0.4/modules/exporting.js"></script -->

<div id="container" style="width: <%=width%>px; height: <%=height%>px; margin: 0 auto"></div>
<!-- Esta é uma adaptação da highchart para Maker 2.x e 3.x feita pela L2 Soluções Tecnológica Ltda - http://www.l2s.com.br/ -->
	</body>
</html>
