﻿<!DOCTYPE html>
<html>
	<head>
		<title>Funil - L2MAKER</title>
		<meta content="text/html; charset=utf-8" http-equiv="content-type">
		<!--[if IE]><base href="<% 
		String baseURL = request.getRequestURL().toString().replace("/l2s/funil/index.jsp", "/");
		out.print(baseURL); %>"></base><![endif]-->
		<!--[if !IE]>--><base href="../.." /><!--<![endif]-->
		<meta name="description" content="www.l2maker.com.br - Dashboard" />
		<meta name="keywords" content="L2S, L2MAKER, API Maker, Softwell Maker, dashboard, Funil, Funnil"/>
		<link rel="icon" href="favicon.ico" type="image/x-icon" />

		<link rel="stylesheet" href="l2s/funil/jquery-ui.css">

		<link rel="stylesheet" href="l2s/funil/bootstrap.css">

		<script src="l2s/funil/jquery-1.10.2.js"></script>
		<script src="l2s/funil/jquery-ui.js"></script>

		<!-- MENU -->
		<link rel="stylesheet" href="l2s/funil/contextmenu/jquery.contextMenu.css" type="text/css" media="screen">
		<script type="text/javascript" src="l2s/funil/contextmenu/jquery.ui.position.min.js"></script>
		<script type="text/javascript" src="l2s/funil/contextmenu/jquery.contextMenu.js"></script>
		<!-- -->
		<!-- Required D3 library -->
		<script src="l2s/funnel/d3.v4.js"></script>

		<!-- D3Funnel source file -->
		<script src="l2s/funnel/d3-funnel.dist.js"></script>

		<script type="text/javascript" src="l2s/commons/core.js"></script>
		<style type="text/css">
			html, body {
				margin: 0;
				padding: 0;
				background: white;
				/*Não permitir selecionar textos*/
				-moz-user-select: none; -webkit-user-select: none; -ms-user-select:none; user-select:none;-o-user-select:none;"
			}

			.layout {
				padding: 15px;
			}

			.item-actions {
				position: absolute;
				right: 4px;
				top: 4px;
			}
			.item-image {
				position: absolute;
				right: 4px;
				bottom: 4px;
			}
			
			.item-group-Graficos {
color: rgb(0, 0, 0);
    background: #EAEFF2 !important;
	border-bottom: 5px solid #17A6DE;
		
}

.chart-titulo {
	margin: auto;
}

		</style>
	<script>
	// Simple but unreliable function to create string hash by Sergey.Shuchkin [t] gmail.com
// alert( strhash('http://www.w3schools.com/js/default.asp') ); // 6mn6tf7st333r2q4o134o58888888888
function strhash() {
	var text = "";
	var possible = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";

	for (var i = 0; i < 15; i++)
		text += possible.charAt(Math.floor(Math.random() * possible.length));
	return text;
}
	</script>
	</head>
<body>
	<div class="layout" unselectable="on" onselectstart="return false;" >
		<%
		String onExecuteAction = request.getParameter("onExecuteAction");
		if((onExecuteAction != null) && !"".equals(onExecuteAction) && !"null".equals(onExecuteAction)) {
		%>
		<div id="actionTextDiv">
			<input type="text" id="actionText" name="actionText" value="">
			<input type="button" id="actionButton" name="actionTextBtn" value="OK"></input>
		</div>
		<script>
		$("#actionButton").click(function() {
			callFlow('<%=onExecuteAction%>', [$("#actionText").val()]);
		});
		</script>
		<%}%>
		<div id="funnil" class="funnil">
		</div>
	</div>

<script type="text/javascript">
	var CHART_COLORS = ["#CFECF4", "#32B990", "#ADAEAE", "#EB8D5E", "#7DCAB1", "#E4E771", "#458CBE",
      "#D94A59", "#DF5353", "#286189", "#F8D4A9"];

	function toChartData(values) {  
		var chartData = {
			labels: [],
			datasets : [
				{
					data : [],
					backgroundColor: [],
					hoverBackgroundColor: []
				}
			]
		}

		for(var i = 0; i < values.length; i++) {
			var item = values[i];
			chartData.labels.push('' + item[0]);
			chartData.datasets[0].data.push(parseFloat(item[1]));
			chartData.datasets[0].backgroundColor.push(CHART_COLORS[i % CHART_COLORS.length]);
			chartData.datasets[0].hoverBackgroundColor.push(CHART_COLORS[i % CHART_COLORS.length]);
		}
		return chartData;
	}
</script>
<script type="text/javascript">
Funil.prototype.add = function(itemDiv, dados, titulo) {
	const FUNNEL_OPTS = {
			chart: {
				bottomPinch: 1,
				curve: {
					enabled: true,
				},
				bottomWidth: 1 / 3,
			},
			block: {
				dynamicHeight: false,
			},
			animate: 200,
		};
	var divTopo = document.createElement('div');
	divTopo.class = 'chart-titulo';
	itemDiv.appendChild(divTopo);

	var divTitulo = document.createElement('span');
	divTitulo.class = 'chart-titulo';
	divTitulo.innerHTML = '<center>' + titulo + '</center>';
	divTopo.appendChild(divTitulo);

	var funilID = "funil" + strhash(itemDiv.id);
	var divGrafico = document.createElement('div');
	divGrafico.id = funilID;
	divGrafico.style.width = '100%'; 
	divGrafico.style.height = '80%';
	itemDiv.appendChild(divGrafico);
	itemDiv._funnel = false;
	//
	setTimeout(function() {
		const chart = new D3Funnel('#' + funilID);
		chart.draw(dados, FUNNEL_OPTS);
		itemDiv._funnel = chart;
	}, 2);

	itemDiv.refreshValues = function(values) {
		itemDiv._funnel.draw(values, FUNNEL_OPTS)
	}
}

Funil.prototype.startAutoRefresh = function(refreshInterval, refreshAll) {
	var dash = this;
	setTimeout(function() { dash.refresh(null); }, 100);
	if(this.refreshInterval > 0) {
		setInterval(function() { dash.autoRefresh(); }, refreshInterval);
	}
}

Funil.prototype.autoRefresh = function() {
	var dash = this;
	if(this.refreshAll) {
		this.refresh(null);
	} else {
		var minValue = null;
		var minDiv = null;
		$('.brick').each(function() {
			var refreshCount = parseInt(this.getAttribute('refresh-count'));
			if(isNaN(refreshCount)) {
				refreshCount = 0;
			}
			if ((minValue === null) || (refreshCount < minValue)) { 
					minValue = refreshCount; 
					minDiv = this;
			}
		});
		if(minDiv) {
			var codigo = minDiv.getAttribute('codigo');
			minDiv.setAttribute('refresh-count', minValue + 1);
			dash.refresh(codigo);
		} else {
			dash.refresh(null);
		}
	}
}

Funil.prototype.fireMouseAction = function(id, item, acao, event) {
	console.log(acao);
	if(this.onMouseEvent) {
		try {
			var x = mouseX(event);
			var y = mouseY(event);
			var resposta = callFlow(this.onMouseEvent, [id, item, acao, x, y]);
			if(event) {
				event.stopPropagation();
			}
			return true;
		} catch (e) {
			alert(e);
		}
	}
	if(event) {
		event.stopPropagation();
	}
	return false;
}

Funil.prototype.fireGetActions = function(id) {
	if(this.onDataRefresh) {
		try {
			var item = this.itens[id];
			if(item && item.menu) {
				return item.menu;
			} else {
				var resposta = callFlow(this.onDataRefresh, [id, 'MENU']);
				if(!resposta) return false;
				resposta = eval('(' + resposta + ')');
				return resposta;
			}
		} catch (e) {
			throw e;
		}
		return false;
	} 
}
</script>
<script type="text/javascript">
	function allowDrop(ev) {
		ev.preventDefault();
	}

	function createCSSSelector (selector, style) {
		if (!document.styleSheets) return;
		if (document.getElementsByTagName('head').length == 0) return;

		var styleSheet,mediaType;

		if (document.styleSheets.length > 0) {
			for (var i = 0, l = document.styleSheets.length; i < l; i++) {
				if (document.styleSheets[i].disabled) 
					continue;
				var media = document.styleSheets[i].media;
				mediaType = typeof media;

				if (mediaType === 'string') {
					if (media === '' || (media.indexOf('screen') !== -1)) {
					  styleSheet = document.styleSheets[i];
					}
				} else if (mediaType=='object') {
					if (media.mediaText === '' || (media.mediaText.indexOf('screen') !== -1)) {
					  styleSheet = document.styleSheets[i];
					}
				}

				if (typeof styleSheet !== 'undefined') 
					break;
			}
		}

		if (typeof styleSheet === 'undefined') {
			var styleSheetElement = document.createElement('style');
			styleSheetElement.type = 'text/css';
			document.getElementsByTagName('head')[0].appendChild(styleSheetElement);

			for (i = 0; i < document.styleSheets.length; i++) {
				if (document.styleSheets[i].disabled) {
					continue;
				}
				styleSheet = document.styleSheets[i];
			}

			mediaType = typeof styleSheet.media;
		}

		if (mediaType === 'string') {
			for (var i = 0, l = styleSheet.rules.length; i < l; i++) {
				if(styleSheet.rules[i].selectorText && styleSheet.rules[i].selectorText.toLowerCase() == selector.toLowerCase()) {
					styleSheet.rules[i].style.cssText = style;
						return;
				}
			}
				styleSheet.addRule(selector,style);
		} else if (mediaType === 'object') {
			var styleSheetLength = (styleSheet.cssRules) ? styleSheet.cssRules.length : 0;
			for (var i = 0; i < styleSheetLength; i++) {
				if (styleSheet.cssRules[i].selectorText && styleSheet.cssRules[i].selectorText.toLowerCase() == selector.toLowerCase()) {
					styleSheet.cssRules[i].style.cssText = style;
					return;
				}
			}
			styleSheet.insertRule(selector + '{' + style + '}', styleSheetLength);
		}
	}

	function drag(ev) {
		ev.dataTransfer.setData("text", ev.target.id);
	}

function mouseX(evt) {
    if (evt.pageX) {
        return evt.pageX;
    } else if (evt.clientX) {
       return evt.clientX + (document.documentElement.scrollLeft ?
           document.documentElement.scrollLeft :
           document.body.scrollLeft);
    } else {
        return null;
    }
}

function mouseY(evt) {
    if (evt.pageY) {
        return evt.pageY;
    } else if (evt.clientY) {
       return evt.clientY + (document.documentElement.scrollTop ?
       document.documentElement.scrollTop :
       document.body.scrollTop);
    } else {
        return null;
    }
}
</script>
<script>
function montarMenu(itens) {
	var menu = new Object();
	for(idx in itens) {
		var item = itens[idx];
		var menuItem = { name: item.titulo };
		if(item.icone) {
			menuItem.icon = item.icone;
		}
		if(item.submenu) {
			menuItem.items = montarMenu(item.submenu);
		}
		menu[item.id] = menuItem;
	}
	return menu;
}

$(function(){
    $.contextMenu({
        selector: '.funil', 
        build: function($trigger, e) {
            // this callback is executed every time the menu is to be shown
            // its results are destroyed every time the menu is hidden
            // e is the original contextmenu event, containing e.pageX and e.pageY (amongst other data)
			var itemDiv = $trigger[0];
			var codigo = itemDiv.getAttribute('codigo');
            return {
                callback: function(key, options) {
                    var m = "clicked: " + key;
                    window.console && console.log(m);
					//alert(m + ':' + codigo); 
					window._funil.fireMouseAction(codigo, key, 'MENU', event);
                },
                items: montarMenu(window._funil.fireGetActions(codigo))
            };
        }
    });
});
</script>
</body>
</html>